#include <stdio.h>
#include <stdlib.h>

# if defined(__MSDOS__) || defined(MSDOS)
# include	<io.h>
# endif
#ifdef MY48
#ifndef FILE_EM48
extern CPU cpu;
#endif
#endif
 
#ifdef MY48
#define get_nibble(a) cpu.rom[a]
#endif
 

typedef char		Nybble;
typedef unsigned long	NAddr;

#define NOADDR		0xffffffffL

extern char	hex[];

#ifdef ANSI
long	GetInt(NAddr *addr, int n);
int	get_nibble(NAddr addr);
WORD20	Disassemble(NAddr, NAddr);
NAddr	Instruction_length(NAddr);

char	*Append16(char *buf, int n);
char	*AppendAddr(char *buf, NAddr addr);
char	*AppendRAddr(char *buf, NAddr pc, long disp, int n, int offset);
char	*AppendField(char *buf, Nybble fn);
char	*AppendDecInt(char *buf, int n);
char	*AppendHexNyb(char *buf, NAddr *addr, int n);
char	*AppendImmNyb(char *buf, NAddr *addr, int n);
char	*AppendStBits(char *buf, int n);
char	*AppendStr(char *buf, char *str);
#else
long	GetInt();
#ifndef MY48
  int	get_nibble();
#endif
long	Disassemble();
NAddr	Instruction_length();

char	*Append16();
char	*AppendAddr();
char	*AppendRAddr();
char	*AppendField();
char	*AppendDecInt();
char	*AppendHexNyb();
char	*AppendImmNyb();
char	*AppendStBits();
char	*AppendStr();
#endif

typedef char	*Bitmap;

#define BITS(s)		((s) /  8)
#define BITSET(m, b)	m[b >> 3] |= (1 << (b & 7))
#define BITCLR(m, b)	m[b >> 3] &= ~(1 << (b & 7))
#define BITTEST(m, b)	(m[b >> 3] & (1 << (b & 7)))

typedef enum {other, branch, call, jump, ujump}	IType;

extern IType	itype;
extern NAddr	target;

#define APPEND_BDIGIT(x, d)	*(x)++ = (char) ((d) + '0')
#define APPEND_CHAR(x, c)	*(x)++ = (char) (c)
#define APPEND_COMMA(x)		*(x)++ = ','; *(x)++ = ' '
#define APPEND_HEXMARK(x)	*(x)++ = '$'
#define APPEND_IMMMARK(x)	*(x)++ = '#'
#define APPEND_TAB(x)		*(x)++ = '\t'
#define TERMINATE(x)		*(x) = '\0'
