/*
        CommandScroll.m
	by Joe Freeman
        Subprocess Example, Release 2.0
        NeXT Computer, Inc.

	You may freely copy, distribute and reuse the code in this example.
	NeXT disclaims any warranty of any kind, expressed or implied, as to
	its fitness for any particular use.
*/

#import <appkit/appkit.h>

/*
 * This object sends its delegate the "userEntered:" message
 * whenever new text is entered in the text object inside this ScrollView
 *
 */
 
@interface CommandScroll:ScrollView
{
    id	docView;
    id	MASTER;
    id	delegate;
    int lastTextCount;
	int doNotAppend;
    int	nAppended;
	// size of the text object the last time this program played with it
    id	machineFont, userFont;
    char *history[100];
    int presentHistory;
    int useHistory;
    int lastHistory;
    int xLength;
    int lastPrintLength;
    int nLastOneWasHistory;
    NXSelPt Begin,End;
    int nRemember;
	// so the user can distinguish what they typed from system output
}
- setMASTER:sender;
- appendString:(char *)buffer;
    // append the buffer to the end of the text object
- clearContents;
- reinsertSpace;
- deleteLastChar;
- userFont;
- machineFont;
- resetLTC;
unsigned short MyNXFilter(unsigned short theChar, int flags, unsigned short charSet);

@end
