#include "hp48.h"
#include "dis48.h"
#include <fcntl.h>

CPU	cpu;

#define NSIZE 524288
#define BSIZE (NSIZE / 2)

int	dopause = 0;

#ifdef ANSI
main(int argc, char **argv)
#else
main(argc, argv)
int	argc;
char	**argv;
#endif
{
	int	s, e;

	if (argc != 3) {
		fprintf(stderr, "Usage: dis48 start end\n");
		exit(1);
		}
	read_rom();
	read_symtab("addr.list");

	if (sscanf(argv[1], "%x", &s) != 1)
		exit(0);
			
	if (sscanf(argv[2], "%x", &e) != 1)
		exit(0);
		
	while (s <= e)
		s = Disassemble(s, e, stdout);
	exit(0);
}
