/**********************************************************************/
/*   Drawing  area  widget -- allows application to draw into window  */
/*   and be called when certain events occur. Very primitive widget.  */
/**********************************************************************/
# include <X11/copyright.h>

/* $XConsortium: TemplateP.h,v 1.4 89/07/21 01:41:48 kit Exp $ */
/* Copyright	Massachusetts Institute of Technology	1987, 1988 */

#ifndef _DrawP_h
#define _DrawP_h

# include "draw.h"
/* include superclass private header file */
#include <X11/CoreP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRDrawResource "DrawResource"

typedef struct {
/* private: */
	int	dummy;
} DrawClassPart;

typedef struct _DrawClassRec {
    CoreClassPart	core_class;
    DrawClassPart	draw_class;
} DrawClassRec;

extern DrawClassRec drawClassRec;

typedef struct {
	/* resources */
	Pixel		foreground;
	XtCallbackList	expose_callback;
	XtCallbackList	resize_callback;

/* private: */
	GC	gc;		/* Normal text.		*/
} DrawPart;

typedef struct _DrawRec {
    CorePart		core;
    DrawPart		draw;
} DrawRec;

#endif /* _DrawP_h */

